
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define DEBUG 0
#define TRUE 1
#define FALSE 0
#define llint unsigned long long int
#define llint64 long long int
#define uint64 llint
#define int64 long long int
#define Sqrt sqrt
#define uint unsigned int
#define bool unsigned char
#define int64 long long int
#define DEBUG 0
#define TRUE 1
#define FALSE 0
#define uint8 unsigned char

typedef struct {int64 re,im;} gauss; gauss *GAUSS;
typedef struct {double re,im;} gaussd;
typedef struct {int64 a,b;} sqrt2; sqrt2 *SQRT2;
typedef struct {double a,b;} sqrt2d;

static bool VERBOSE=FALSE;
static uint TARGET_RANK=0;
static double MESTRE_BOUND=-1000.0;

#include "newprimes.c" // GAUSS and SQRT2 now prime-denoted

static int incr_nullity(uint64 *M,int OLD_ROWS,int NEW_ROWS,int LOWER_BOUND)
{int m,n; int k=0;
 while (NEW_ROWS)
 {n=OLD_ROWS; NEW_ROWS--;
  for (m=0;m<OLD_ROWS;m++) if (M[n]&(1ULL<<BSF(M[m]))) M[n]^=M[m];
  if (M[n]) OLD_ROWS++; else {k++; M[OLD_ROWS]=M[OLD_ROWS+NEW_ROWS];}
  if (NEW_ROWS+k<LOWER_BOUND) return -1;} return k;}

/* changes M in place, returns the nullity (or -1 if LOWER_BOUND is hit)
   so that OLD+NEW-nullity is the number of nonzero rows. */

static int dimkerF2lb(uint64 *M,int m,int n,int lb)
{return incr_nullity(M,0,m,lb);}

static int do_nullity /* augmented nullity, incremental */
(int cr,int rows,uint64 *M,uint64 *A,uint *v,int vc,int lb,int mx)
{int ex,in,nr1=cr,nr2=cr;
 ex=1+((vc&1)==0);
 M[rows]=A[0]; if (ex==2) M[rows+1]=A[1];
 in=incr_nullity(M,rows,ex,lb-cr-vc+ex);
 if (in>=0)
 {nr1=cr+in; if (nr1>=mx) return nr1;
  if (vc>ex) nr1=do_nullity(nr1,rows+ex-in,M,A+ex,v+ex,vc-ex,lb,mx);
  if (nr1>=mx) return nr1;}
 M[rows]=A[0]^(1ULL<<v[0]); if (ex==2) M[rows+1]=A[1]^(1ULL<<v[1]);
 in=incr_nullity(M,rows,ex,lb-cr-vc+ex);
 if (in>=0)
 {nr2=cr+in; if (nr2>=mx) return nr2;
  if (vc>ex) nr2=do_nullity(nr2,rows+ex-in,M,A+ex,v+ex,vc-ex,lb,mx);
  if (nr2>=mx) return nr2;}
 if (nr1>nr2) return nr1; return nr2;}

static int do_augmented(gauss *pf,int sz,uint64 *M,int sh,int lb,int mx)
{int c=0,r,j,in; uint64 C[sz+sh],A[sz+sh]; uint v[sz+sh];
 for (r=0;r<sh;r++) C[r]=M[r];
 for (j=1;j<=sz;j++)
 {if (pf[j].im) {A[c]=M[j-1+sh]; v[c++]=j-1+sh;} else C[r++]=M[j-1+sh];}
 in=incr_nullity(C,0,r,lb-c); if (in>=mx || c==0) return in;
 return do_nullity(in,r-in,C,A,v,c,lb,mx);}

////////////////////////

#define KROLIM 9592
uint8 BIG_KRO_TABLE[KROLIM][(KROLIM+7)/8];
uint8 GAUSS_KRO_TABLE[KROLIM][(KROLIM+3)/4];
uint8 SQRT2_KRO_TABLE[KROLIM][(KROLIM+3)/4];
uint8 *KRO_ALL_TABLE[KROLIM];

static void load_files()
{int c,e; FILE *F;
 F=fopen("GAUSSdata.9592","r");
 if (!F) F=fopen("/home/watkins/CONG/CONGCODE/GAUSSdata.9592","r");
 for (c=0;c<KROLIM;c++) for (e=0;e<(KROLIM+3)/4;e++)
			  fread(&GAUSS_KRO_TABLE[c][e],1,1,F); fclose(F);
 F=fopen("SQRT2data.9592","r");
 if (!F) F=fopen("/home/watkins/CONG/CONGCODE/SQRT2data.9592","r");
 for (c=0;c<KROLIM;c++) for (e=0;e<(KROLIM+3)/4;e++)
			  fread(&SQRT2_KRO_TABLE[c][e],1,1,F); fclose(F);
 F=fopen("KROdata.9592","r");
 if (!F) F=fopen("/home/watkins/CONG/CONGCODE/KROdata.9592","r");
 for (c=0;c<KROLIM;c++) for (e=0;e<(KROLIM+7)/8;e++)
			  fread(&BIG_KRO_TABLE[c][e],1,1,F); fclose(F);
 for (c=0;c<KROLIM;c++) KRO_ALL_TABLE[c]=malloc((PRIMES[c]+7)/8);
 F=fopen("KROall.9592","r");
 if (!F) F=fopen("/home/watkins/CONG/CONGCODE/KROall.9592","r");
 for (c=0;c<KROLIM;c++) for (e=0;e<(PRIMES[c]+7)/8;e++)
			  fread(&KRO_ALL_TABLE[c][e],1,1,F); fclose(F);
 printf("# FILES LOADED\n");}

static void write_files()
{int c,e; FILE *F;
 F=fopen("GAUSSdata.9592","w");
 for (c=0;c<KROLIM;c++) for (e=0;e<(KROLIM+3)/4;e++)
			  fwrite(&GAUSS_KRO_TABLE[c][e],1,1,F); fclose(F);
 F=fopen("SQRT2data.9592","w");
 for (c=0;c<KROLIM;c++) for (e=0;e<(KROLIM+3)/4;e++)
			  fwrite(&SQRT2_KRO_TABLE[c][e],1,1,F); fclose(F);
 F=fopen("KROdata.9592","w");
 for (c=0;c<KROLIM;c++) for (e=0;e<(KROLIM+7)/8;e++)
			  fwrite(&BIG_KRO_TABLE[c][e],1,1,F); fclose(F);
 F=fopen("KROall.9592","w");
 for (c=0;c<KROLIM;c++) for (e=0;e<(PRIMES[c]+7)/8;e++)
			  fwrite(&KRO_ALL_TABLE[c][e],1,1,F); fclose(F);
 printf("FILES WRITTEN\n");}

static int kro(int A,int B);

static void kro_all_init()
{int c,e; for (c=0;c<KROLIM;c++) KRO_ALL_TABLE[c]=malloc((PRIMES[c]+7)/8);
 for (c=0;c<KROLIM;c++) for (e=0;e<(PRIMES[c]+7)/8;e++) KRO_ALL_TABLE[c][e]=0;
 for (c=0;c<KROLIM;c++) for (e=1;e<PRIMES[c];e++)
  KRO_ALL_TABLE[c][e>>3]|=kro(e,PRIMES[c])<<(e&7);}

static void big_kro_init()
{int k,c,e;
 for (c=0;c<KROLIM;c++) for (e=0;e<(KROLIM+7)/8;e++) BIG_KRO_TABLE[c][e]=0;
 for (c=0;c<KROLIM;c++) for (e=0;e<KROLIM;e++)
 {if (c==e) continue; k=kro(PRIMES[c],PRIMES[e]);
  BIG_KRO_TABLE[c][e>>3]|=k<<(e&7);}}

static int kro2(int w1,int w2,int p1,int p2)
{if (w1<KROLIM && w2<KROLIM) return (BIG_KRO_TABLE[w1][w2>>3]>>(w2&7))&1;
 return kro(p1,p2);}

static bool gauss_kronecker(gauss a,gauss b);

static void gauss_kro_init()
{int k1,k2,c,e; gauss a,b; uint pc,pe; GAUSS[0].re=1; GAUSS[0].im=1;
 for (c=0;c<KROLIM;c++) for (e=0;e<KROLIM/4;e++) GAUSS_KRO_TABLE[c][e]=0;
 for (c=0;c<KROLIM;c++) for (e=1;e<KROLIM;e++) // 1+i not on bottom
 {pc=PRIMES[c]; a.re=GAUSS[c].re; a.im=GAUSS[c].im;
  pe=PRIMES[e]; b.re=GAUSS[e].re; b.im=GAUSS[e].im;
  if ((pc%4)==3) {a.re=pc; a.im=0;} if ((pe%4)==3) {b.re=pe; b.im=0;}
  if (a.im<0) a.im=-a.im; if (b.im<0) b.im=-b.im;
  if (c==e) k1=0; else k1=gauss_kronecker(a,b);
  if (a.im>0 && b.im>0) {b.im=-b.im; k2=gauss_kronecker(a,b);}
  else k2=k1; GAUSS_KRO_TABLE[c][e>>2]|=(k1+2*k2)<<(2*(e&3));}}

static int kro_gauss(int w1,int w2,gauss p1,gauss p2)
{if (w1<KROLIM && w2<KROLIM)
 {int k,opp=(p1.im<0)^(p2.im<0); k=GAUSS_KRO_TABLE[w1][w2>>2]>>(2*(w2&3))&3;
  if (opp) k>>=1; else k&=1; return k;} return gauss_kronecker(p1,p2);}

static bool sqrt2_kronecker(sqrt2 a,sqrt2 b);

static void sqrt2_kro_init()
{int k1,k2,c,e; sqrt2 Y,Z; uint pc,pe; SQRT2[0].a=0; SQRT2[0].b=1;
 for (c=0;c<KROLIM;c++) for (e=0;e<KROLIM/4;e++) SQRT2_KRO_TABLE[c][e]=0;
 for (c=0;c<KROLIM;c++) for (e=1;e<KROLIM;e++) // s2 not on bottom
 {pc=PRIMES[c]; Y.a=SQRT2[c].a; Y.b=SQRT2[c].b;
  pe=PRIMES[e]; Z.a=SQRT2[e].a; Z.b=SQRT2[e].b;
  if ((pc%8)==3 || (pc%8)==5) {Y.a=pc; Y.b=0;}
  if ((pe%8)==3 || (pe%8)==5) {Z.a=pe; Z.b=0;}
  if (Y.b<0) Y.b=-Y.b; if (Z.b<0) Z.b=-Z.b;
  if (c==e) k1=0; else k1=sqrt2_kronecker(Y,Z);
  if (Y.b>0 && Z.b>0) {Z.b=-Z.b; k2=sqrt2_kronecker(Y,Z);}
  else k2=k1; SQRT2_KRO_TABLE[c][e>>2]|=(k1+2*k2)<<(2*(e&3));}}

static int kro_sqrt2(int w1,int w2,sqrt2 p1,sqrt2 p2)
{if (w1<KROLIM && w2<KROLIM)
 {int k,opp=(p1.b<0)^(p2.b<0); k=SQRT2_KRO_TABLE[w1][w2>>2]>>(2*(w2&3))&3;
  if (opp) k>>=1; else k&=1; return k;} return sqrt2_kronecker(p1,p2);}

////////////////////////////////////////////////

static void gauss_mult(gauss a,gauss b,gauss *c)
{c->re=(a.re*b.re-a.im*b.im); c->im=(a.re*b.im+b.re*a.im);}

static void gauss_sub(gauss a,gauss b,gauss *c)
{c->re=(a.re-b.re); c->im=(a.im-b.im);}

static void gauss_conj_mult(gauss a,gauss b,gauss *c)
{c->re=(a.re*b.re+a.im*b.im); c->im=(-a.re*b.im+b.re*a.im);}

static int64 gauss_norm(gauss a) {return (a.re*a.re+a.im*a.im);}

static void gauss_reduce(gauss a,gauss b,gauss *r) /* check |r| < |b| ? */
{gauss t,q; double n; gaussd af,bf,cf;
 af.re=(double) a.re; af.im=(double) a.im;
 bf.re=(double) b.re; bf.im=(double) b.im;
 cf.re=(af.re*bf.re+af.im*bf.im); cf.im=(-af.re*bf.im+bf.re*af.im);
 n=bf.re*bf.re+bf.im*bf.im; q.re=rint(cf.re/n); q.im=rint(cf.im/n);
 gauss_mult(q,b,&t); gauss_sub(a,t,r);}

static uint gauss_factor(uint64 *F,int sz,gauss *pf,int *W,int *X)
{uint n=1,i;
 for (i=0;i<sz;i++)
 {if ((F[i]&3)==3) {pf[n].re=-(int64) F[i]; X[n]=W[i]; pf[n++].im=0;}
  else {pf[n].re=GAUSS[W[i]].re; X[n]=W[i]; pf[n++].im=GAUSS[W[i]].im;
        pf[n].re=GAUSS[W[i]].re; X[n]=W[i]; pf[n++].im=-GAUSS[W[i]].im;}}
 return n-1;}

#define U 5
static int m4g[4][4]={{U,0,U,0},{0,U,1,U},{U,1,U,1},{0,U,1,U}};
static int m8g[8][8]={{U,0,U,1,U,1,U,0},{0,U,1,U,1,U,0,U},
		      {U,0,U,0,U,1,U,1},{1,U,1,U,0,U,0,U},
		      {U,1,U,0,U,0,U,1},{1,U,0,U,0,U,1,U},
		      {U,1,U,1,U,0,U,0},{0,U,0,U,1,U,1,U}};
static bool gauss_kronecker(gauss a,gauss b)
{int64 t; gauss A,B,R; int k=0;
 A.re=a.re; A.im=a.im; B.re=b.re; B.im=b.im; gauss_reduce(A,B,&R);
 while (TRUE)
 {while ((R.re&3)==0 && (R.im&3)==0) {R.re>>=2; R.im>>=2;}
  if ((R.re&1)==0 && (R.im&1)==0) {R.re>>=1; R.im>>=1; k^=m4g[B.re&3][B.im&3];}
  if ((R.re&1)==(R.im&1))
  {t=R.re; R.re=(t+R.im)>>1; R.im=(R.im-t)>>1; k^=m8g[B.re&7][B.im&7];}
  if ((R.re&1)==0) {t=R.re; R.re=-R.im; R.im=t; k^=m4g[B.re&3][B.im&3];}
  if (R.im==0 && (R.re==1 || R.re==-1)) return k;
  gauss_reduce(B,R,&A); B=R; R=A;}}

////////////////////////

static void at2_matA_even(gauss *pf,int sz,uint64 *M) // imag part is even
{int i;
 for (i=1;i<=sz;i++) {if ((pf[i].im&3)==2) {M[0]|=(1<<i); M[i]|=(1<<0);}}}

static void getmatA_even(gauss *pf,int sz,uint64 *M,int *W) // zero padded
{int i,j; uint e,A[sz+1];
 if (VERBOSE) printf("Isogeny A, even d\n");
 for (i=0;i<=sz;i++) M[i]=A[i]=0; at2_matA_even(pf,sz,M);
 for (i=0;i<=sz;i++) A[i]=M[i]; // copy from at2
 for (i=1;i<=sz;i++)
 {if (VERBOSE) printf("Prime %lld+%lldi\n",pf[i].re,pf[i].im);
  for (j=1;j<i;j++)
  {e=kro_gauss(W[j],W[i],pf[j],pf[i]);
   A[i]+=e; A[j]+=e; M[i]|=(e<<j); M[j]|=(e<<i);
   if (pf[j].re==pf[i].re && pf[j].im==-pf[i].im)
   {e=M[i]&1; A[i]+=e; A[j]+=e; M[i]^=(e<<j); M[j]^=(e<<i);}}}
 for (i=1;i<=sz;i++) M[i]|=(A[i]&1)<<i;}

static int doitA_even(gauss *pf,int sz,uint64 *M,int *W)
{int ks; getmatA_even(pf,sz,M,W);
 ks=dimkerF2lb(M,sz+1,sz+1,TARGET_RANK+1); return ks-1;}

static int augAeven(gauss *pf,int sz,uint64 *M,int *W,int lb,int mx)
{getmatA_even(pf,sz,M,W); return do_augmented(pf,sz,M,1,lb+1,mx+1)-1;}

////////////////////////

static void at2_matA_35mod8(gauss *pf,int sz,uint64 *M)
{int i; M[0]=1; for (i=1;i<=sz;i++) if ((pf[i].im&3)==2) M[i]|=(1<<0);}

static void getmatA_35mod8(gauss *pf,int sz,uint64 *M,int *W) // zero padded
{int i,j,A[sz+1]; uint e; if (VERBOSE) printf("Isogeny A, 3 or 5 mod 8\n");
 for (i=0;i<=sz;i++) M[i]=A[i]=0; at2_matA_35mod8(pf,sz,M);
 for (i=1;i<=sz;i++)
 {if (VERBOSE) printf("Prime %lld+%lldi\n",pf[i].re,pf[i].im);
  for (j=1;j<i;j++)
  {e=kro_gauss(W[j],W[i],pf[j],pf[i]);
   A[i]+=e; A[j]+=e; M[i]|=(e<<j); M[j]|=(e<<i);
   if (pf[j].re==pf[i].re && pf[j].im==-pf[i].im)
   {e=M[i]&1; A[i]+=e; A[j]+=e; M[i]^=(e<<j); M[j]^=(e<<i);}}}
 for (i=1;i<=sz;i++) M[i]|=(A[i]&1)<<i;}

static int doitA_35mod8(gauss *pf,int sz,uint64 *M,int *W) // zero padded
{int ks; getmatA_35mod8(pf,sz,M,W);
 ks=dimkerF2lb(M,sz+1,sz+1,TARGET_RANK+1); return ks-1;}

static void at2_matA_17mod8(gauss *pf,int sz,uint64 *M,uint dmod8,int *W)
{int i; static int TABLE1[8][8]={{0,0,0,0,0,0,0,0},{0,0,1,0,1,0,0,0},
				 {0,0,0,0,0,0,0,0},{1,0,1,0,0,0,0,0},
				 {0,0,0,0,0,0,0,0},{1,0,0,0,0,0,1,0},
				 {0,0,0,0,0,0,0,0},{0,0,0,0,1,0,1,0}};
 static int TABLE7[8][8]={{0,0,0,0,0,0,0,0},{0,0,0,0,1,0,1,0},
			  {0,0,0,0,0,0,0,0},{1,0,0,0,0,0,1,0},
			  {0,0,0,0,0,0,0,0},{1,0,1,0,0,0,0,0},
			  {0,0,0,0,0,0,0,0},{0,0,1,0,1,0,0,0}};
 M[0]=1; if (dmod8==7) M[0]=3;
 for (i=1;i<=sz;i++)
 {if (dmod8==1 && TABLE1[pf[i].re&7][pf[i].im&7]) M[1]|=(1<<(1+i));
  if (dmod8==7 && TABLE7[pf[i].re&7][pf[i].im&7]) M[1]|=(1<<(1+i));
  if ((pf[i].im&3)==2) M[i+1]|=(1<<0);
  if (TABLE7[pf[i].re&7][pf[i].im&7]) M[i+1]|=(1<<1);}}

static void getmatA_17mod8(gauss *pf,int sz,uint64 *M,uint dmod8,int *W)
{int i,j,A[sz+2]; uint e;
 if (VERBOSE) printf("Isogeny A, 1 or 7 mod 8, %d mod 8\n",dmod8);
 for (i=0;i<=sz+1;i++) M[i]=A[i]=0; at2_matA_17mod8(pf,sz,M,dmod8,W);
 for (i=1;i<=sz;i++)
 {if (VERBOSE) printf("Prime %lld+%lldi\n",pf[i].re,pf[i].im);
  for (j=1;j<i;j++)
  {e=kro_gauss(W[j],W[i],pf[j],pf[i]);
   A[i]+=e; A[j]+=e; M[i+1]|=(e<<(j+1)); M[j+1]|=(e<<(i+1));
   if (pf[j].re==pf[i].re && pf[j].im==-pf[i].im)
   {e=M[i+1]&1; A[i]+=e; A[j]+=e; M[i+1]^=(e<<(j+1)); M[j+1]^=(e<<(i+1));}}}
 for (i=1;i<=sz;i++) M[i+1]|=(A[i]&1)<<(i+1);}

static int doitA_17mod8(gauss *pf,int sz,uint64 *M,uint dmod8,int *W)
{int ks; getmatA_17mod8(pf,sz,M,dmod8,W);
 ks=dimkerF2lb(M,sz+2,sz+2,TARGET_RANK+1); return ks-1;}

static int augAodd(gauss *pf,int sz,uint64 *M,int *W,int lb,int mx)
{int e1,e2,j;
 getmatA_35mod8(pf,sz,M,W);
 e1=do_augmented(pf,sz,M,1,lb+1,mx+1)-1; if (e1>=mx) return e1;
 for (j=sz;j>=1;j--) M[j+1]=(M[j]&~1ULL)<<1; M[0]=M[1]=0;
 at2_matA_17mod8(pf,sz,M,TARGET_RANK&1?7:1,W); /* 7:1 seems not to matter? */
 e2=do_augmented(pf,sz,M,2,lb+1,mx+1)-1; if (e2>=mx) return e2;
 if (e1>e2) return e1; return e2;}

/************************************************************************/

static void sqrt2_mult(sqrt2 a,sqrt2 b,sqrt2 *c)
{c->a=(a.a*b.a+2*a.b*b.b); c->b=(a.a*b.b+b.a*a.b);}

static void sqrt2_sub(sqrt2 a,sqrt2 b,sqrt2 *c)
{c->a=(a.a-b.a); c->b=(a.b-b.b);}

static void sqrt2_conj_mult(sqrt2 a,sqrt2 b,sqrt2 *c)
{c->a=(a.a*b.a-2*a.b*b.b); c->b=(-a.a*b.b+b.a*a.b);}

static int64 sqrt2_norm(sqrt2 a) {return (a.a*a.a-2*a.b*a.b);}

static void sqrt2_reduce(sqrt2 a,sqrt2 b,sqrt2 *r)
{sqrt2 q,t; double n; sqrt2d af,bf,cf;
 af.a=(double) a.a; af.b=(double) a.b;
 bf.a=(double) b.a; bf.b=(double) b.b;
 cf.a=(af.a*bf.a-2.0*af.b*bf.b); cf.b=(-af.a*bf.b+bf.a*af.b);
 n=bf.a*bf.a-2.0*bf.b*bf.b; q.a=rint(cf.a/n); q.b=rint(cf.b/n);
 sqrt2_mult(q,b,&t); sqrt2_sub(a,t,r);}

#define U 5
#define SQRT2_FLOAT 1.4142135623730950488016887242096980786
static int m4s[4][4]={{U,U,U,U},{0,1,1,0},{U,U,U,U},{1,1,0,0}};
static int m8s[8][8]={{U,U,U,U,U,U,U,U},{0,1,0,0,0,1,0,0},
		      {U,U,U,U,U,U,U,U},{0,0,0,1,0,0,0,1},
		      {U,U,U,U,U,U,U,U},{1,0,1,1,1,0,1,1},
		      {U,U,U,U,U,U,U,U},{1,1,1,0,1,1,1,0}};
static int recip[4][4][4][4]=
  {{{{U,U,U,U},{U,U,U,U},{U,U,U,U},{U,U,U,U}},
    {{U,U,U,U},{U,U,U,U},{U,U,U,U},{U,U,U,U}},
    {{U,U,U,U},{U,U,U,U},{U,U,U,U},{U,U,U,U}},
    {{U,U,U,U},{U,U,U,U},{U,U,U,U},{U,U,U,U}}},
   {{{U,U,U,U},{0,0,0,0},{U,U,U,U},{0,0,0,0}},
    {{U,U,U,U},{0,1,1,0},{U,U,U,U},{1,1,0,0}},
    {{U,U,U,U},{0,1,0,1},{U,U,U,U},{0,1,0,1}},
    {{U,U,U,U},{0,0,1,1},{U,U,U,U},{1,0,0,1}}},
   {{{U,U,U,U},{U,U,U,U},{U,U,U,U},{U,U,U,U}},
    {{U,U,U,U},{U,U,U,U},{U,U,U,U},{U,U,U,U}},
    {{U,U,U,U},{U,U,U,U},{U,U,U,U},{U,U,U,U}},
    {{U,U,U,U},{U,U,U,U},{U,U,U,U},{U,U,U,U}}},
   {{{U,U,U,U},{0,1,0,1},{U,U,U,U},{0,1,0,1}},
    {{U,U,U,U},{0,1,1,0},{U,U,U,U},{1,1,0,0}},
    {{U,U,U,U},{0,0,0,0},{U,U,U,U},{0,0,0,0}},
    {{U,U,U,U},{0,0,1,1},{U,U,U,U},{1,0,0,1}}}};

static bool sqrt2_kronecker(sqrt2 a,sqrt2 b)
{int64 t,n; sqrt2 Y,Z,R; int k=0;
 Y.a=a.a; Y.b=a.b; Z.a=b.a; Z.b=b.b; sqrt2_reduce(Y,Z,&R);
 while (TRUE)
 {if (R.a+R.b*SQRT2_FLOAT<0.0) {R.a=-R.a; R.b=-R.b; k^=(Z.b&1);}
  n=sqrt2_norm(R); while ((n&3)==0) {R.a>>=1; R.b>>=1; n>>=2;}
  if (!(n&1)) {t=R.a; R.a=R.b; R.b=t>>1; k^=m8s[Z.a&7][Z.b&7]; n>>=1; n=-n;}
  if (n==1 || n==-1) return k^recip[R.a&3][R.b&3][Z.a&3][Z.b&3];
  if (n<0) {R.a=-R.a+(R.b<<1); R.b=-R.a+R.b; k^=m4s[Z.a&3][Z.b&3];}
  k^=recip[R.a&3][R.b&3][Z.a&3][Z.b&3]; sqrt2_reduce(Z,R,&Y); Z=R; R=Y;}}

static uint sqrt2_factor(uint64 *F,int sz,sqrt2 *pf,int *W,int *X)
{uint n=1,i;
 for (i=0;i<sz;i++)
 {if ((F[i]&7)==3 || (F[i]&7)==5)
  {pf[n].a=(int64) F[i]; X[n]=W[i]; pf[n++].b=0;}
  else {pf[n].a=SQRT2[W[i]].a; X[n]=W[i]; pf[n++].b=SQRT2[W[i]].b;
        pf[n].a=SQRT2[W[i]].a; X[n]=W[i]; pf[n++].b=-SQRT2[W[i]].b;}}
 return n-1;}

////////////////////////

static int KRO_S2[8][4]={{1,1,1,1},{0,1,0,0},{1,1,1,1},{0,0,0,1},
			 {1,1,1,1},{1,0,1,1},{1,1,1,1},{1,1,1,0}}; // (s2|)

static void at2_matB_odd(sqrt2 *pf,int sz,uint64 *M,uint dmod4)
{int i; static int TABLE1[4][4]={{1,1,1,1},{0,0,1,1},{1,1,1,1},{1,0,0,1}};
 static int TABLE3[4][4]={{1,1,1,1},{0,1,0,1},{1,1,1,1},{0,1,0,1}};
 static int TABLE[4][4]={{1,1,1,1},{0,1,1,0},{1,1,1,1},{1,1,0,0}};
 if (dmod4==3) M[0]=1;
 for (i=1;i<=sz;i++)
 {if (VERBOSE) printf("Prime %lld+%lld*s2\n",pf[i].a,pf[i].b);
  if (dmod4==1 && TABLE1[pf[i].a&3][pf[i].b&3]) M[0]|=(1<<i);
  if (dmod4==3 && TABLE3[pf[i].a&3][pf[i].b&3]) M[0]|=(1<<i);
  if (TABLE[pf[i].a&3][pf[i].b&3]) M[i]|=(1<<0);}}

static void getmatB_odd(sqrt2 *pf,int sz,uint64 *M,uint dmod4,int *W)
{int i,j; uint u,e,A[sz+1];
 if (VERBOSE) printf("Isogeny B, odd d %d mod 4\n",dmod4);
 for (i=0;i<=sz;i++) M[i]=A[i]=0; at2_matB_odd(pf,sz,M,dmod4);
 for (i=1;i<=sz;i++) for (j=i+1;j<=sz;j++)
 {e=kro_sqrt2(W[j],W[i],pf[j],pf[i]); A[i]+=e; M[i]|=(e<<j);
  u=e^recip[pf[j].a&3][pf[j].b&3][pf[i].a&3][pf[i].b&3]; A[j]+=u; M[j]|=(u<<i);
  if (pf[j].a==pf[i].a && pf[j].b==-pf[i].b)
  {e=KRO_S2[pf[i].a&7][pf[i].b&3]; A[i]+=e; M[i]^=(e<<j);
   e=KRO_S2[pf[j].a&7][pf[j].b&3]; A[j]+=e; M[j]^=(e<<i);}}
 for (i=1;i<=sz;i++) M[i]|=(A[i]&1)<<i;}

static int doitB_odd(sqrt2 *pf,int sz,uint64 *M,uint dmod4,int *W)
{int ks; getmatB_odd(pf,sz,M,dmod4,W);
 ks=dimkerF2lb(M,sz+1,sz+1,TARGET_RANK+1); return ks-1;}

static int augBodd(sqrt2 *pf,int sz,uint64 *M,int *W,int lb,int mx)
{int e1,e2,j;
 getmatB_odd(pf,sz,M,1,W);
 e1=do_augmented((gauss*) pf,sz,M,1,lb+1,mx+1)-1; if (e1>=mx) return e1;
 M[0]=1; for (j=1;j<=sz;j++) M[j]&=~1ULL; at2_matB_odd(pf,sz,M,3);
 e2=do_augmented((gauss*) pf,sz,M,1,lb+1,mx+1)-1; if (e2>=mx) return e2;
 if (e1>e2) return e1; return e2;}

static void at2_matB_even57mod8(sqrt2 *pf,int sz,uint64 *M)
{int i; static int TABLEa[4][4]={{1,1,1,1},{0,1,0,1},{1,1,1,1},{0,1,0,1}};
 static int TABLEb[4][4]={{1,1,1,1},{0,1,1,0},{1,1,1,1},{1,1,0,0}};
 M[0]=1; for (i=1;i<=sz;i++)
 {if (VERBOSE) printf("Prime %lld+%lld*s2\n",pf[i].a,pf[i].b);
  if (TABLEa[pf[i].a&3][pf[i].b&3]) M[0]|=(1<<i);
  if (TABLEb[pf[i].a&3][pf[i].b&3]) M[i]|=(1<<0);}}

static void getmatB_even57mod8(sqrt2 *pf,int sz,uint64 *M,int *W)
{int i,j; uint e,u,A[sz+1];
 if (VERBOSE) printf("Isogeny B, 10 or 14 mod 16\n");
 for (i=0;i<=sz;i++) M[i]=A[i]=0; at2_matB_even57mod8(pf,sz,M);
 for (i=1;i<=sz;i++) for (j=i+1;j<=sz;j++)
 {e=kro_sqrt2(W[j],W[i],pf[j],pf[i]); A[i]+=e; M[i]|=(e<<j);
  u=e^recip[pf[j].a&3][pf[j].b&3][pf[i].a&3][pf[i].b&3]; A[j]+=u; M[j]|=(u<<i);
  if (pf[j].a==pf[i].a && pf[j].b==-pf[i].b)
  {e=KRO_S2[pf[i].a&7][pf[i].b&3]; A[i]+=e; M[i]^=(e<<j);
   e=KRO_S2[pf[j].a&7][pf[j].b&3]; A[j]+=e; M[j]^=(e<<i);}}
 for (i=1;i<=sz;i++) M[i]|=(A[i]&1)<<i;}

static int doitB_even57mod8(sqrt2 *pf,int sz,uint64 *M,int *W) // zero padded
{int ks; getmatB_even57mod8(pf,sz,M,W);
 ks=dimkerF2lb(M,sz+1,sz+1,TARGET_RANK+1); return ks-1;}

static void at2_matB_even13mod8(sqrt2 *pf,int sz,uint64 *M,uint dmod8)
{int i; static int TABLE1[8][4]={{1,1,1,1},{0,1,0,1},{1,1,1,1},{0,1,0,1},
				 {1,1,1,1},{0,1,0,1},{1,1,1,1},{0,1,0,1}};
 static int TABLE2a[8][4]={{1,1,1,1},{0,0,1,0},{1,1,1,1},{1,1,0,1},
			   {1,1,1,1},{1,1,0,1},{1,1,1,1},{0,0,1,0}};
 static int TABLE2b[8][4]={{1,1,1,1},{0,0,0,1},{1,1,1,1},{0,1,0,0},
			   {1,1,1,1},{1,1,1,0},{1,1,1,1},{1,0,1,1}};
 static int TABLE3[8][4]={{1,1,1,1},{0,1,1,0},{1,1,1,1},{1,1,0,0},
			  {1,1,1,1},{0,1,1,0},{1,1,1,1},{1,1,0,0}};
 static int TABLE4[8][4]={{1,1,1,1},{0,1,0,0},{1,1,1,1},{0,0,0,1},
			  {1,1,1,1},{1,0,1,1},{1,1,1,1},{1,1,1,0}};
 M[0]=1; if (dmod8==1) M[0]=3;
 for (i=1;i<=sz;i++)
 {if (VERBOSE) printf("Prime %lld+%lld*s2\n",pf[i].a,pf[i].b);
  if (TABLE1[pf[i].a&7][pf[i].b&3]) M[0]|=(1<<(i+1));
  if (dmod8==1 && TABLE2a[pf[i].a&7][pf[i].b&3]) M[1]|=(1<<(i+1));
  if (dmod8==3 && TABLE2b[pf[i].a&7][pf[i].b&3]) M[1]|=(1<<(i+1));
  if (TABLE3[pf[i].a&7][pf[i].b&3]) M[i+1]|=(1<<0);
  if (TABLE4[pf[i].a&7][pf[i].b&3]) M[i+1]|=(1<<1);}}

static void getmatB_even13mod8(sqrt2 *pf,int sz,uint64 *M,uint dmod8,int *W)
{int i,j; uint u,e,A[sz+2];
 if (VERBOSE) printf("Isogeny B, 2 or 6 mod 16, %d mod 16\n",dmod8*2);
 for (i=0;i<=sz+1;i++) M[i]=A[i]=0; at2_matB_even13mod8(pf,sz,M,dmod8);
 for (i=1;i<=sz;i++) for (j=i+1;j<=sz;j++)
 {e=kro_sqrt2(W[j],W[i],pf[j],pf[i]);
  u=e^recip[pf[j].a&3][pf[j].b&3][pf[i].a&3][pf[i].b&3];
  A[i]+=e; M[i+1]|=(e<<(j+1)); A[j]+=u; M[j+1]|=(u<<(i+1));
  if (pf[j].a==pf[i].a && pf[j].b==-pf[i].b)
  {e=(M[i+1]&2)>>1; A[i]+=e; M[i+1]^=(e<<(j+1));
   e=(M[j+1]&2)>>1; A[j]+=e; M[j+1]^=(e<<(i+1));}}
 for (i=1;i<=sz;i++) M[i+1]|=(A[i]&1)<<(i+1);}

static int doitB_even13mod8(sqrt2 *pf,int sz,uint64 *M,uint dmod8,int *W)
{int ks; getmatB_even13mod8(pf,sz,M,dmod8,W);
 ks=dimkerF2lb(M,sz+2,sz+2,TARGET_RANK+1); return ks-1;}

static int augBeven(sqrt2 *pf,int sz,uint64 *M,int *W,int lb,int mx)
{int e1,e2,j;
 getmatB_even57mod8(pf,sz,M,W);
 e1=do_augmented((gauss*) pf,sz,M,1,lb+1,mx+1)-1; if (e1>=mx) return e1;
 for (j=sz;j>=1;j--) M[j+1]=(M[j]&~1ULL)<<1; M[0]=M[1]=0;
 at2_matB_even13mod8(pf,sz,M,TARGET_RANK&1?3:1);
 e2=do_augmented((gauss*) pf,sz,M,2,lb+1,mx+1)-1; if (e2>=mx) return e2;
 if (e1>e2) return e1; return e2;}

////////////////////////////////////////////////

static void at2_matC_odd(sqrt2 *pf,int sz,uint64 *M,uint dmod4)
{int i; static int TABLE1[4][4]={{1,1,1,1},{0,1,0,1},{1,1,1,1},{0,1,0,1}};
 static int TABLE3[4][4]={{1,1,1,1},{0,0,1,1},{1,1,1,1},{1,0,0,1}};
 static int TABLEb[4][4]={{1,1,1,1},{0,1,0,1},{1,1,1,1},{0,1,0,1}};
 for (i=1;i<=sz;i++)
 {if (VERBOSE) printf("Prime %lld+%lld*s2\n",pf[i].a,pf[i].b);
  if (dmod4==1 && TABLE1[pf[i].a&3][pf[i].b&3]) M[0]|=(1<<i);
  if (dmod4==3 && TABLE3[pf[i].a&3][pf[i].b&3]) M[0]|=(1<<i);
  if (TABLEb[pf[i].a&3][pf[i].b&3]) M[i]|=(1<<0);}}

static void getmatC_odd(sqrt2 *pf,int sz,uint64 *M,uint dmod4,int *W)
{int i,j; uint u,e,A[sz+1];
 if (VERBOSE) printf("Isogeny C, odd d %d mod 4\n",dmod4);
 for (i=0;i<=sz;i++) M[i]=A[i]=0; if (dmod4==3) M[0]=1;
 at2_matC_odd(pf,sz,M,dmod4); for (i=1;i<=sz;i++) A[i]=M[i];
 for (i=1;i<=sz;i++) for (j=i+1;j<=sz;j++)
 {e=kro_sqrt2(W[j],W[i],pf[j],pf[i]); A[i]+=e; M[i]|=(e<<j);
  u=e^recip[pf[j].a&3][pf[j].b&3][pf[i].a&3][pf[i].b&3]; A[j]+=u; M[j]|=(u<<i);
  if (pf[j].a==pf[i].a && pf[j].b==-pf[i].b)
  {e=KRO_S2[pf[i].a&7][pf[i].b&3]; A[i]+=e; M[i]^=(e<<j);
   e=KRO_S2[pf[j].a&7][pf[j].b&3]; A[j]+=e; M[j]^=(e<<i);}}
 for (i=1;i<=sz;i++) M[i]|=(A[i]&1)<<i;}

static int doitC_odd(sqrt2 *pf,int sz,uint64 *M,uint dmod4,int *W)
{int ks; getmatC_odd(pf,sz,M,dmod4,W);
 ks=dimkerF2lb(M,sz+1,sz+1,TARGET_RANK+1); return ks-1;}

static int augCodd(sqrt2 *pf,int sz,uint64 *M,int *W,int lb,int mx)
{int e1,e2,j;
 getmatC_odd(pf,sz,M,1,W);
 e1=do_augmented((gauss*) pf,sz,M,1,lb+1,mx+1)-1; if (e1>=mx) return e1;
 M[0]=1; for (j=1;j<=sz;j++) M[j]&=~1ULL; at2_matC_odd(pf,sz,M,3);
 e2=do_augmented((gauss*) pf,sz,M,1,lb+1,mx+1)-1; if (e2>=mx) return e2;
 if (e1>e2) return e1; return e2;}

static void at2_matC_even13mod8(sqrt2 *pf,int sz,uint64 *M)
{int i; for (i=1;i<=sz;i++)
 {if (VERBOSE) printf("Prime %lld+%lld*s2\n",pf[i].a,pf[i].b);
  if ((pf[i].b&1)==1) {M[0]|=(1<<i); M[i]=(1<<0);}}}

static void getmatC_even13mod8(sqrt2 *pf,int sz,uint64 *M,int *W)
{int i,j; uint u,e,A[sz+1];
 if (VERBOSE) printf("Isogeny C, 2 or 6 mod 16\n");
 for (i=0;i<=sz;i++) M[i]=A[i]=0;
 at2_matC_even13mod8(pf,sz,M); for (i=1;i<=sz;i++) A[i]=M[i];
 for (i=1;i<=sz;i++) for (j=i+1;j<=sz;j++)
 {e=kro_sqrt2(W[j],W[i],pf[j],pf[i]); A[i]+=e; M[i]|=(e<<j);
  u=e^recip[pf[j].a&3][pf[j].b&3][pf[i].a&3][pf[i].b&3]; A[j]+=u; M[j]|=(u<<i);
  if (pf[j].a==pf[i].a && pf[j].b==-pf[i].b)
  {e=KRO_S2[pf[i].a&7][pf[i].b&3]; A[i]+=e; M[i]^=(e<<j);
   e=KRO_S2[pf[j].a&7][pf[j].b&3]; A[j]+=e; M[j]^=(e<<i);}}
 for (i=1;i<=sz;i++) M[i]|=(A[i]&1)<<i;}

static int doitC_even13mod8(sqrt2 *pf,int sz,uint64 *M,int *W)
{int ks; getmatC_even13mod8(pf,sz,M,W);
 ks=dimkerF2lb(M,sz+1,sz+1,TARGET_RANK+1); return ks-1;}

static void at2_matC_even57mod8(sqrt2 *pf,int sz,uint64 *M,uint dmod8)
{int i; static int TABLEa[8][4]={{1,1,1,1},{0,1,0,1},{1,1,1,1},{0,1,0,1},
				 {1,1,1,1},{0,1,0,1},{1,1,1,1},{0,1,0,1}};
 static int TABLEb5[8][4]={{1,1,1,1},{0,0,0,1},{1,1,1,1},{0,1,0,0},
			   {1,1,1,1},{1,1,1,0},{1,1,1,1},{1,0,1,1}};
 static int TABLEb7[8][4]={{1,1,1,1},{0,0,1,0},{1,1,1,1},{1,1,0,1},
			   {1,1,1,1},{1,1,0,1},{1,1,1,1},{0,0,1,0}};
 for (i=1;i<=sz;i++)
 {if (VERBOSE) printf("Prime %lld+%lld*s2\n",pf[i].a,pf[i].b);
  if (TABLEa[pf[i].a&7][pf[i].b&3]) M[0]|=(1<<(i+1));
  if (dmod8==5 && TABLEb5[pf[i].a&7][pf[i].b&3]) M[1]|=(1<<(i+1));
  if (dmod8==7 && TABLEb7[pf[i].a&7][pf[i].b&3]) M[1]|=(1<<(i+1));
  if (TABLEa[pf[i].a&7][pf[i].b&3]) M[i+1]|=(1<<0);
  if (TABLEb7[pf[i].a&7][pf[i].b&3]) M[i+1]|=(1<<1);}}

static void getmatC_even57mod8(sqrt2 *pf,int sz,uint64 *M,uint dmod8,int *W)
{int i,j; uint u,e,A[sz+2];
 if (VERBOSE) printf("Isogeny C, 10 or 14 mod 16, %d mod 16\n",dmod8*2);
 for (i=0;i<=sz+1;i++) M[i]=A[i]=0; if (dmod8==5) {M[0]=2; M[1]=1;}
 at2_matC_even57mod8(pf,sz,M,dmod8); for (i=1;i<=sz;i++) A[i]=M[i+1]&1;
 for (i=1;i<=sz;i++) for (j=i+1;j<=sz;j++)
 {e=kro_sqrt2(W[j],W[i],pf[j],pf[i]);
  u=e^recip[pf[j].a&3][pf[j].b&3][pf[i].a&3][pf[i].b&3];
  A[i]+=e; M[i+1]|=(e<<(j+1)); A[j]+=u; M[j+1]|=(u<<(i+1));
  if (pf[j].a==pf[i].a && pf[j].b==-pf[i].b)
  {e=KRO_S2[pf[i].a&7][pf[i].b&3]; A[i]+=e; M[i+1]^=(e<<(j+1));
   e=KRO_S2[pf[j].a&7][pf[j].b&3]; A[j]+=e; M[j+1]^=(e<<(i+1));}}
 for (i=1;i<=sz;i++) M[i+1]|=(A[i]&1)<<(i+1);}

static int doitC_even57mod8(sqrt2 *pf,int sz,uint64 *M,uint dmod8,int *W)
{int ks; getmatC_even57mod8(pf,sz,M,dmod8,W);
 ks=dimkerF2lb(M,sz+2,sz+2,TARGET_RANK+1); return ks-1;}

static int augCeven(sqrt2 *pf,int sz,uint64 *M,int *W,int lb,int mx)
{int e1,e2;
 getmatC_even13mod8(pf,sz,M,W);
 e1=do_augmented((gauss*) pf,sz,M,1,lb+1,mx+1)-1; if (e1>=mx) return e1;
 getmatC_even57mod8(pf,sz,M,TARGET_RANK&1?7:5,W);
 e2=do_augmented((gauss*) pf,sz,M,2,lb+1,mx+1)-1; if (e2>=mx) return e2;
 if (e1>e2) return e1; return e2;}

/************************************************************************/

static int KROn1[4]={0,0,0,1},
           KRO2[8]={0,0,0,1,0,1,0,0},KROn2[8]={0,0,0,0,0,1,0,1};

static int kro(int A,int B)
{int r,v=0; uint k=0; while (!(B&1)) {B>>=1; v++;} if (v&1) k=KRO2[A&7]; A=A%B;
 while (1)
 {if (A==0) return(k); v=0; while (!(A&1)) {A>>=1; v++;}
  if (v&1) k^=KRO2[B&7];
  r=B-A; if (r>0) {if (A&B&2) k^=1; B=A; A=r;} else A=-r;}}

static void getmat0_odd(uint64 *pf,uint64 *M,int n,int *W)
{int u,i,e,f,A[n],V[n],j; for (i=0;i<n;i++) M[i]=M[i+n]=A[i]=V[i]=0;
 for (i=0;i<n;i++)
 {e=KRO2[pf[i]&7]; f=KROn2[pf[i]&7];
  M[i]=(e<<i)+(e<<(n+i)); M[i+n]=(e<<i)+(f<<(n+i));}
 for (i=0;i<n;i++) for (j=i+1;j<n;j++)
 {e=kro2(W[j],W[i],pf[j],pf[i]); V[i]+=e; A[i]|=e<<j;
  u=e^((pf[j]&3)==3 && (pf[i]&3)==3); V[j]+=u; A[j]|=u<<i;}
 for (i=0;i<n;i++) {A[i]|=(V[i]&1)<<i; M[i]^=A[i]; M[i+n]^=A[i]<<n;}}

static int doit0_odd(uint64 *pf,uint64 *M,int n,int *W)
{getmat0_odd(pf,M,n,W); return dimkerF2lb(M,2*n,2*n,TARGET_RANK);}

static int aug0odd(uint64 *pf,uint64 *M,int n,int *W,int lb,int mx)
{int j; uint64 C[2*n],A[2*n]; uint v[2*n]; getmat0_odd(pf,M,n,W);
 for (j=0;j<n;j++) {A[2*j]=M[j]; A[2*j+1]=M[n+j]; v[2*j]=j; v[2*j+1]=j+n;}
 return do_nullity(0,0,C,A,v,2*n,lb,mx);}

static void getmat0_even(uint64 *pf,uint64 *M,int n,int *W)
{int u,i,e,f,A[n],B[n],V[n],j; for (i=0;i<n;i++) M[i]=M[i+n]=A[i]=B[i]=V[i]=0;
 for (i=0;i<n;i++)
 {e=KRO2[pf[i]&7]; f=KROn1[pf[i]&3];
  M[i]=(e<<i)+(e<<(n+i)); M[i+n]=(e<<i)+(f<<(n+i));}
 for (i=0;i<n;i++) for (j=i+1;j<n;j++)
 {e=kro2(W[j],W[i],pf[j],pf[i]); V[i]+=e; A[i]|=e<<j; B[j]|=e<<i;
  u=e^((pf[j]&3)==3 && (pf[i]&3)==3); V[j]+=u; A[j]|=u<<i; B[i]|=u<<j;}
 for (i=0;i<n;i++)
 {A[i]|=(V[i]&1)<<i; B[i]|=(V[i]&1)<<i; M[i]^=A[i]<<n; M[i+n]^=B[i];}}

static int doit0_even(uint64 *pf,uint64 *M,int n,int *W)
{getmat0_even(pf,M,n,W); return dimkerF2lb(M,2*n,2*n,TARGET_RANK);}

static int aug0even(uint64 *pf,uint64 *M,int n,int *W,int lb,int mx)
{int j; uint64 C[2*n],A[2*n]; uint v[2*n]; getmat0_even(pf,M,n,W);
 for (j=0;j<n;j++) {A[2*j]=M[j]; A[2*j+1]=M[n+j]; v[2*j]=j+n; v[2*j+1]=j;}
 return do_nullity(0,0,C,A,v,2*n,lb,mx);}


/************************************************************************/

static int aug0(uint64 *F,int nump,int *W,int lb,int m)
{uint64 M[30]; int r0; if (F[0]==2) r0=aug0even(F+1,M,nump-1,W+1,lb,m);
                       else r0=aug0odd(F,M,nump,W,lb,m); return r0;}

static int augA(uint64 *F,int nump,int *W,int lb,int m)
{uint64 M[30]; gauss pf[30]; int sz,rA; int X[30];
 if (F[0]==2)
 {sz=gauss_factor(F+1,nump-1,pf,W+1,X); rA=augAeven(pf,sz,M,X,lb,m);}
 else {sz=gauss_factor(F,nump,pf,W,X); rA=augAodd(pf,sz,M,X,lb,m);} return rA;}

static int augB(uint64 *F,int nump,int *W,int lb,int m)
{uint64 M[30]; sqrt2 s2[30]; int sz,rB; int X[30];
 if (F[0]==2)
 {sz=sqrt2_factor(F+1,nump-1,s2,W+1,X); rB=augBeven(s2,sz,M,X,lb,m);}
 else {sz=sqrt2_factor(F,nump,s2,W,X); rB=augBodd(s2,sz,M,X,lb,m);} return rB;}

static int augC(uint64 *F,int nump,int *W,int lb,int m)
{uint64 M[30]; sqrt2 s2[30]; int sz,rC; int X[30];
 if (F[0]==2)
 {sz=sqrt2_factor(F+1,nump-1,s2,W+1,X); rC=augCeven(s2,sz,M,X,lb,m);}
 else {sz=sqrt2_factor(F,nump,s2,W,X); rC=augCodd(s2,sz,M,X,lb,m);} return rC;}

static int doit_augmented(uint64 *F,int nump,int ee,uint *AUG,int *W)
{int r0,rA,rB,rC,rk=TARGET_RANK;
 // reorder depending on parity case? or d even/odd?
 rA=augA(F,nump,W,ee,rk+(rk==ee)); if (rA<ee) return rA; if (rA<rk) rk=rA;
 rB=augB(F,nump,W,ee,rk+(rk==ee)); if (rB<ee) return rB; if (rB<rk) rk=rB;
 r0=aug0(F,nump,W,ee,rk+(rk==ee)); if (r0<ee) return r0; if (r0<rk) rk=r0;
 rC=augC(F,nump,W,ee,rk+(rk==ee)); if (rC<ee) return rC; if (rC<rk) rk=rC;
 AUG[0]=r0; AUG[1]=rA; AUG[2]=rB; AUG[3]=rC; return rk;}

static int doit0(uint64 *F,int nump,int *W)
{int r0; uint64 M[30]; if (F[0]==2) r0=doit0_even(F+1,M,nump-1,W+1);
                       else r0=doit0_odd(F,M,nump,W); return r0;}

static int doitA(uint64 *F,int nump,int *W)
{uint64 M[30]; gauss pf[30]; int sz,i,x,rA; int X[30];
 if (F[0]==2) {sz=gauss_factor(F+1,nump-1,pf,W+1,X); rA=doitA_even(pf,sz,M,X);}
 else {x=1; for (i=0;i<nump;i++) x*=(F[i]&7); sz=gauss_factor(F,nump,pf,W,X);
       if ((x&7)==3 || (x&7)==5) rA=doitA_35mod8(pf,sz,M,X);
       else rA=doitA_17mod8(pf,sz,M,x&7,X);} return rA;}

static int doitB(uint64 *F,int nump,int *W)
{uint64 M[30]; sqrt2 s2[30]; int sz,i,x,rB; int X[30];
 if (F[0]==2)
 {x=1; for (i=1;i<nump;i++) x*=(F[i]&7); sz=sqrt2_factor(F+1,nump-1,s2,W+1,X);
  if ((x&7)==5 || (x&7)==7) rB=doitB_even57mod8(s2,sz,M,X);
  else rB=doitB_even13mod8(s2,sz,M,x&7,X);}
 else {x=1; for (i=0;i<nump;i++) x*=(F[i]&3);
       sz=sqrt2_factor(F,nump,s2,W,X); rB=doitB_odd(s2,sz,M,x&3,X);}
 return rB;}

static int doitC(uint64 *F,int nump,int *W)
{uint64 M[30]; sqrt2 s2[30]; int sz,i,x,rC; int X[30];
 if (F[0]==2)
 {x=1; for (i=1;i<nump;i++) x*=(F[i]&7); sz=sqrt2_factor(F+1,nump-1,s2,W+1,X);
  if ((x&7)==5 || (x&7)==7) rC=doitC_even57mod8(s2,sz,M,x&7,X);
  else rC=doitC_even13mod8(s2,sz,M,X);}
 else {x=1; for (i=0;i<nump;i++) x*=(F[i]&3);
       sz=sqrt2_factor(F,nump,s2,W,X); rC=doitC_odd(s2,sz,M,x&3,X);}
 return rC;}

static int doit_work(uint64 *F,int nump,int ee,int *W)
{int i,r0,rA,rB,rC,rk;
 r0=doit0(F,nump,W); if (r0<ee) return r0;
 rA=doitA(F,nump,W); if (rA<ee) return rA;
 rB=doitB(F,nump,W); if (rB<ee) return rB;
 rC=doitC(F,nump,W); if (rC<ee) return rC;
 if ((r0&1)!=(rA&1) || (rA&1)!=(rB&1) || (rB&1)!=(rC&1))
 {printf("PARITY!"); for (i=0;i<nump;i++) printf(" %lld",F[i]); printf("\n");}
 rk=r0; if (rA<rk) rk=rA; if (rB<rk) rk=rB; if (rC<rk) rk=rC; return rk;}

static double mestre_sum2(uint64 s,uint64 t,int LIM);
static double mestre_sum_thr(uint64 s,uint64 t,int LIM);
static uint64 surv=0,output=0;
#define DUAL_MB 0.0
#define MESTRE_FUNC mestre_sum2
static void out_it(uint64 *pf,int nump,int r)
{int i; uint64 dd=1,d=1; double f; surv++; // 2^47*10^5 < 2^64
 for (i=0;i<nump;i++) {if (d>(1ULL<<47)/pf[i]) {dd=d; d=1;} d*=pf[i];}
 if (DUAL_MB>0.0 && MESTRE_BOUND<100.0) f=MESTRE_FUNC(d,dd,10000);
 else f=MESTRE_BOUND; if (f<MESTRE_BOUND-20.0) return;
 if (MESTRE_BOUND<100.0) f=MESTRE_FUNC(d,dd,100000);
 else f=MESTRE_BOUND; if (f<MESTRE_BOUND) return; output++;
 if (dd==1) printf("%lld/%lld %lld  %.3f  ",output,surv,d,f);
 else printf("%lld/%lld %lld*%lld  %.3f  ",output,surv,d,dd,f);
 printf("%lld",pf[0]); for (i=1;i<nump;i++) printf(" %lld",pf[i]);
 printf("\n"); fflush(stdout);}

/* fiddly bit to handle more than 64-bit precision, groan */
#define POW2_28 (268435456.0)
#define POW2_56 (POW2_28*POW2_28)

typedef uint64* word3;
static int do_cmp3(uint64 *A,uint64 *B)
{if (A[0]<B[0]) return -1; if (A[0]>B[0]) return 1;
 if (A[1]<B[1]) return -1; if (A[1]>B[1]) return 1;
 if (A[2]<B[2]) return -1; if (A[2]>B[2]) return 1; return 0;}

static void do_mult3(uint64 *A,uint64 *B,uint64 *R) // A,R can be the same(!)
{R[0]=A[0]*B[2]+A[1]*B[1]+A[2]*B[0]; R[1]=A[1]*B[2]+A[2]*B[1]; R[2]=A[2]*B[2];
 R[1]+=(R[2]>>28); R[2]&=(1<<28)-1; R[0]+=(R[1]>>28); R[1]&=(1<<28)-1;}

static int do_root(uint64 *A,uint64 *B,int r) // A is LIM, B is PROD
{double n=POW2_56*A[0]+POW2_28*A[1]+A[2],d=POW2_56*B[0]+POW2_28*B[1]+B[2];
 int i; uint64 C[3],Q[3],Qr[3]; double q=rint(exp(log(n/d)/r));
 if (q>PRIME_LIMIT) return PRIME_LIMIT; Q[2]=q; Q[1]=0; Q[0]=0;
 Qr[2]=1; Qr[1]=0; Qr[0]=0; for (i=0;i<r;i++) do_mult3(Qr,Q,Qr);
 do_mult3(B,Qr,C); if (do_cmp3(C,A)<=0) return Q[2]; return Q[2]-1;}

static int do_logp(uint64 *A,uint64 *B,uint64 *p) // log_p(A/B), modifies B
{int c=-1; while (do_cmp3(B,A)<=0) {c++; do_mult3(B,p,B);} return c;}

static uint64 FINAL_PRIME=(1ULL<<63)-1;
static uint64 PIVOT=-1;
#define WRONG_PARITY(P,r) ((((r&1)==1 && (P&7)<4)) || ((r&1)==0 && (P&7)>4))
#define RIGHT_PARITY(P,r) ((((r&1)==0 && (P&7)<4)) || ((r&1)==1 && (P&7)>4))
static uint64 START_ARRAY[32];
static void recurse_new
(int rk,uint64 *pf,int nump,uint w,
 uint64 prod,uint64 *PROD,uint64 *LIM,int *W,bool START_AT)
{int e,u,aug,needed; uint64 p,P[3],R[3]; uint z; uint AUG[8]; int BOUND;
 if (!PRIMES[w]) e=0;
 else {uint64 R[3],P[3]; R[0]=PROD[0]; R[1]=PROD[1]; R[2]=PROD[2];
       P[0]=P[1]=0; P[2]=PRIMES[w]; e=do_logp(LIM,R,P);}
 if (e<0) {printf("Bad in do_logp?\n"); exit(1);}
 if (e==0 && RIGHT_PARITY(prod,rk))
 {u=doit_work(pf,nump,rk,W); if (u>=rk) out_it(pf,nump,u);}
 if (e==0) return;
 aug=doit_augmented(pf,nump,rk-2*e,AUG,W); if (aug<rk-2*e) return;
 if (aug>=rk && RIGHT_PARITY(prod,rk))
 {u=doit_work(pf,nump,rk,W); if (u>=rk) out_it(pf,nump,u);}
 needed=(rk-aug+1)/2; if (needed<=0) needed=1; BOUND=do_root(LIM,PROD,needed);
 for (z=w;PRIMES[z]<=BOUND && PRIMES[z] &&
	  (PIVOT!=nump || PRIMES[z]<=FINAL_PRIME);z++)
 {p=PRIMES[z]; pf[nump]=p; if (START_AT && p<START_ARRAY[nump]) continue;
  if ((rk-AUG[1])==2*e && (p%4)==3) continue;
  if ((rk-AUG[2])==2*e && ((p%8)==3 || (p%8)==5)) continue;
  if ((rk-AUG[3])==2*e && ((p%8)==3 || (p%8)==5)) continue;
  P[0]=P[1]=0; P[2]=p; do_mult3(PROD,P,R);
  W[nump]=z; recurse_new(rk,pf,nump+1,z+1,prod*p,R,LIM,W,
			 START_AT && p==START_ARRAY[nump]);}}

static double *PVAL,*APVAL;
static uint64 RECIP[9592];
static void start_ap()
{double L; int p,u; int i,c; for (c=0;PRIMES[c]<100000;c++);
 PVAL=malloc(c*sizeof(double)); APVAL=malloc(c*sizeof(double));
 for (i=0;i<c;i++)
 {p=PRIMES[i]; u=2*GAUSS[i].re; if ((u&7)==6) u=-u; if ((p&7)!=1) u=-u;
  if ((p&3)==3 || p==2) u=0; L=logf(p);
  RECIP[i]=1+0xffffffffffffffffULL/p;
  PVAL[i]=2.0*L/(1.0+p); APVAL[i]=-u*L/(1.0+p);}}

#define umul_ppmm(hi_prod, lo_prod, u, v) \
  __asm__ ("mulq %3"  : "=a" (lo_prod), "=d" (hi_prod) :\
	   "%0" ((uint64)(u)), "rm" ((uint64)(v)))

static inline uint64 my_mod(uint64 a,uint64 c) // return a%PRIMES[c]
{uint64 hi,lo; umul_ppmm(hi,lo,a,RECIP[c]); return a-hi*PRIMES[c];}

static uint kro_all(x,y) {return (KRO_ALL_TABLE[(y)][(x)>>3]>>((x)&7))&1;}
static double mestre_sum2(uint64 s,uint64 t,int LIM) // about 1K/sec, slow
{double S=0.0; int i,k,x; uint64 p; S+=PVAL[0];
 for (i=1;PRIMES[i] && PRIMES[i]<LIM;i++) // precompute RECIP[p] as double?
 {p=PRIMES[i]; //  if (t==1) x=s%p; else x=((s%p)*(t%p))%p;
  if (t==1) x=my_mod(s,i); else x=my_mod(my_mod(s,i)*my_mod(t,i),i);
  if (x==0) k=0; else k=1-2*kro_all(x,i);
  S+=PVAL[i]+k*APVAL[i];} return S;}
// From rank8 10^16 data: 35.0 is 2.28% 37.6 1%, 40.0 0.42% 45.0 0.055%
// From rank8 10^15 data: 35.0 is 2.4%, 37.8 1%, 40.0 0.5%, 45.0 0.1%
// From rank7 10^14 data: 35.0 is 2.3%, 37.6 1%, 40.0 0.44% 45.0 0.055%
// From rank7 10^13 data: 35.0 is 2.5%, 38.0 1%, 40.0 0.55% 45.0 0.1%
// From rank6 10^11 data: 35.0 is 2.8%, 38.5 1%, 40.0 0.7%, 45.0 0.15%

#define THR 1
static double THR_VAL[THR+1];
static pthread_t THREAD[THR+1];
uint64 MES_LIM,MES_s,MES_t;
void* thread_sum(void *A)
{int i,x,k,w=*(int*)(A); uint64 p; double S=0.0;
 uint64 LIM=MES_LIM,s=MES_s,t=MES_t;
 for (i=w;PRIMES[i] && PRIMES[i]<LIM;i+=THR)
 {p=PRIMES[i]; //  if (t==1) x=s%p; else x=((s%p)*(t%p))%p;
  if (t==1) x=my_mod(s,i); else x=my_mod(my_mod(s,i)*my_mod(t,i),i);
  if (x==0) k=0; else k=1-2*kro_all(x,i);
  S+=PVAL[i]+k*APVAL[i];} THR_VAL[w]=S; return NULL;}

static double mestre_sum_thr(uint64 s,uint64 t,int LIM)
{int i,A[THR]; double S=PVAL[0]; MES_LIM=LIM; MES_s=s; MES_t=t;
 for (i=i;i<=THR;i++) A[i]=i;
 for (i=1;i<=THR;i++) pthread_create(&THREAD[i],NULL,thread_sum,(void*) &A[i]);
 for (i=1;i<=THR;i++) pthread_join(THREAD[i],NULL);
 for (i=1;i<=THR;i++) S+=THR_VAL[i]; return S;}

#include <sys/time.h>
static int64 gclock()
{int64 x; struct timeval tv; gettimeofday(&tv,NULL);
 x=tv.tv_sec; x*=1000000; x+=tv.tv_usec; return x;}

static double timeme(llint st) {return ((double) (gclock()-st))/1000000.0;}

static int find_prime(int p)
{int c; for (c=0;p>=PRIMES[c];c++) if (PRIMES[c]==p) return c;
 printf("Is %d really prime?\n",p); exit(1);}

static void fix_primes(char *S,uint64 *F,int *W,int *nump,int *w)
{int p=0; int wp; bool RANGE=FALSE;
 while (S[0])
 {if (S[0]==',') {F[*nump]=p; W[*nump]=find_prime(p); *nump=*nump+1; p=0;}
  if (S[0]=='+') {*w=find_prime(p); return;}
  if (S[0]=='-') {*w=find_prime(p); p=0; RANGE=TRUE;}
  if (S[0]>='0' && S[0]<='9') p=p*10+(S[0]-'0'); S++;}
 if (RANGE) {PIVOT=*nump; FINAL_PRIME=p; return;}
 F[*nump]=p; wp=find_prime(p); W[*nump]=wp; *w=wp+1; *nump=*nump+1;}

static void make_start_at(char *S)
{int c,w=0;
 while (S[0]) {c=0; while (S[0] && S[0]!=',') {c*=10; c+=S[0]-'0'; S++;}
               START_ARRAY[w++]=c; if (S[0]) S++;} START_ARRAY[w]=0;}

#define MILLION ((1000ULL)*(1000ULL))
#define BILLION ((1000ULL)*(1000ULL)*(1000ULL))
#include <string.h>
int main(int argc,char **argv)
{uint64 F[30],prod,i,c; int W[30],nump,w,u; int64 START;
 uint64 PROD[3],LIMIT[3],MULT[3],TEMP; char STR[64];
 F[0]=0; PRIME_LIMIT=100*MILLION; for (i=0;i<16;i++) START_ARRAY[i];
 printf("# PRIME_LIMIT is %d, THREADS is %d\n",PRIME_LIMIT,THR);
 init_gauss_primes(); start_ap();
#if 0
 START=gclock(); sqrt2_kro_init(); printf("SQRT2 INIT %.2fs\n",timeme(START));
 START=gclock(); gauss_kro_init(); printf("GAUSS INIT %.2fs\n",timeme(START));
 START=gclock(); big_kro_init(); printf("KRO INIT %.2fs\n",timeme(START));
 START=gclock(); kro_all_init(); printf("KRO_ALL INIT %.2fs\n",timeme(START));
 write_files();
#else
 load_files();
#endif
 TARGET_RANK=6; LIMIT[0]=LIMIT[1]=0; LIMIT[2]=100000;
 do_mult3(LIMIT,LIMIT,LIMIT); MESTRE_BOUND=-1000.0; strcpy(STR,"10^10");
 if (argc>1) TARGET_RANK=atoi(argv[1]);
 if (argc>2)
 {if (argv[2][0]=='b')
  {sprintf(STR,"2^%s",argv[2]+1);
   LIMIT[0]=LIMIT[1]=0; LIMIT[2]=1; MULT[0]=MULT[1]=0; MULT[2]=2;
   c=atoi(argv[2]+1); for (i=0;i<c;i++) do_mult3(LIMIT,MULT,LIMIT);}
  else if (argv[2][0]=='d')
  {sprintf(STR,"10^%s",argv[2]+1);
   LIMIT[0]=LIMIT[1]=0; LIMIT[2]=1; MULT[0]=MULT[1]=0; MULT[2]=10;
   c=atoi(argv[2]+1); for (i=0;i<c;i++) do_mult3(LIMIT,MULT,LIMIT);}
  else {sprintf(STR,"%s",argv[2]); TEMP=strtoull(argv[2],NULL,10);
        LIMIT[1]=TEMP>>28; LIMIT[2]=TEMP&((1<<28)-1);
	LIMIT[0]=LIMIT[1]>>28; LIMIT[1]&=(1<<28)-1;}}
 if (argc>3) MESTRE_BOUND=atof(argv[3]);
 nump=w=0; if (argc>4) fix_primes(argv[4],F,W,&nump,&w);
 if (argc>5) make_start_at(argv[5]);
 prod=1; PROD[0]=PROD[1]=0; PROD[2]=1; MULT[0]=MULT[1]=0;
 for (i=0;i<nump;i++) {prod*=F[i]; MULT[2]=F[i]; do_mult3(PROD,MULT,PROD);}
 START=gclock(); u=0;
 if (START_ARRAY[0]!=0)
 {printf("# START_AT");
  while (START_ARRAY[u]) printf(" %lld",START_ARRAY[u++]); printf("\n");}
 recurse_new(TARGET_RANK,F,nump,w,prod,PROD,LIMIT,W,START_ARRAY[0]!=0);
 printf("# r=%d D=%s: Survivors %lld, "
	"Mestre %lld [%.1f/%.2f%%], in %.2fs\n",
	TARGET_RANK,STR,surv,output,
	MESTRE_BOUND,surv==0?0.0:100.0*output/surv,timeme(START)); return 0;}
